' CDTP.inc
' CLASS definitions

AUTODEFINE "OFF"

' Types used to create objects to pass data into the Class SetParam
' Used with CDTPObject
TYPE BObj
	UINT fgcol, bgcol
ENDTYPE

' Used with CDTPRect and CDTPEllipse
TYPE RObj
	INT left, top, width, height
	UINT fgcol, bgcol
ENDTYPE

' Used with CDTPCircle
TYPE CObj
	INT x, y, radius
	UINT fgcol, bgcol
ENDTYPE

'--------------------------------------------------------------------------

' BASE CLASS
CLASS CDTPObject
	DECLARE CDTPObject()
	DECLARE SetWindow(pointer win)
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw()
PROTECTED
	UINT m_fgcol, m_bgcol
    POINTER m_win
ENDCLASS

'--------------------------------------------------------------------------

' RECTANGLE CLASS (derived class) - inherits CDTPObject (Base Class)
CLASS CDTPRect, CDTPObject
	DECLARE CDTPRect()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw()
PROTECTED
	INT m_left, m_top, m_width, m_height
ENDCLASS

'--------------------------------------------------------------------------

' ELLIPSE CLASS (derived class) - inherits CDTPObject (Base Class)
'CLASS CDTPEllipse, CDTPRect, CDTPObject - not implemented in EB
CLASS CDTPEllipse, CDTPObject
	DECLARE CDTPEllipse()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw()
PROTECTED
	' Members same as those in CDTPRect ...
	INT m_left, m_top, m_width, m_height
ENDCLASS

'--------------------------------------------------------------------------

' CIRCLE CLASS (derived class) - inherits CDTPObject (Base Class)
CLASS CDTPCircle, CDTPObject
	DECLARE CDTPCircle()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw()
PROTECTED
	INT m_x, m_y, m_radius
ENDCLASS

'--------------------------------------------------------------------------
